ECHO OFF
COLOR 2
mode con: cols=160 lines=30

if exist "%cd%\Backup\" ( 
  for /f "skip=5 tokens=1,2,4 delims= " %%a in (
   'dir /ad /tc "%cd%\Backup\."') do IF "%%c"=="." (
    set "dt=%%a"
    set backup=Backup created on: %%a, %%b
  )
) else ( 
  set backup=No backup found
)

if exist "%cd%\Install\path.txt" ( 
set /p apb=< Install\path.txt
goto MENU
  )
) else ( 
goto start
)

:START
Echo These are your current drives.
Echo -----------------------------
wmic logicaldisk get caption,volumename
Echo -----------------------------
set /p Input=What drive is APB installed on (Leave blank for manual path): 

IF "%Input%"=="" (GOTO PATH) ELSE (GOTO FIND)

:FIND
cls
echo Hold on while we look for your APB folder. This might take a few minutes depending on your drive size.
for /d /r "%Input%:\" %%i in ("APB Reloaded") do @if exist "%%i" set apb=%%i
set apb=%apb:"=%
cls
echo We found an APB folder in the following direcotry: %apb%

SET /P AREYOUSURE=Is this the correct path to your APB folder? (Y/[N]): 
IF /I "%AREYOUSURE%" NEQ "Y" GOTO PATH
@echo %APB%> Install\path.txt
cls

:MENU
COLOR 2
cls
SET M==""
ECHO -v1.22---------------------------------
ECHO Please select one of the options below.
ECHO ------------------------------By Tobii-
ECHO B - Create/Restore backup - [%backup%]
ECHO 1 - Set/correct APB path - [%apb%]
ECHO 2 - Install Last Stage Names - [%lsn%]
ECHO 3 - Install Login Screen Fix (3 versions) - [%lsf%]
ECHO 4 - Install Configs (4 versions) - [%lqc%]
ECHO 5 - Install Theme Removal - [%tr%]
ECHO 6 - Install Ambient Sound Removal - [%asr%]
ECHO 7 - Install Misc Fixes (disable videos, remove music, disable vivox.exe) - [%mf%]
ECHO 8 - Install Particle Fixes (5 options) - [%epf%]
ECHO 9 - Install Always Sprint + Crouch Hold - [%scf%]
ECHO 0 - Install No fog shader only - [%nfs%]
ECHO S - Install Shaders collection (No fog, crosshair, no bloom, no color correction, outline shader (Includes settings file)) - [%SHADERS%]
ECHO Q - EXIT
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO MENU) ELSE (GOTO MENU_LIST)

:MENU_LIST
IF %M%==1 GOTO MENU_CHECK
IF %M%==2 GOTO LSN
IF %M%==3 GOTO LSF_PROMPT
IF %M%==4 GOTO LQC_PROMPT
IF %M%==5 GOTO TR
IF %M%==6 GOTO ASR
IF %M%==7 GOTO MF
IF %M%==8 GOTO EPF_PROMPT
IF %M%==9 GOTO SCF
IF %M%==0 GOTO nfs
IF %M%==N GOTO NPC_PROMPT
IF %M%==Q GOTO EXIT
IF %M%==S GOTO SHADERS
IF %M%==n GOTO NPC_PROMPT
IF %M%==q GOTO EXIT
IF %M%==s GOTO SHADERS
IF %M%==b GOTO BACKUP_PROMPT
IF %M%==B GOTO BACKUP_PROMPT

:MENU_CHECK
IF /I "%M%" NEQ "1" GOTO MENU

:PATH
cls
echo Please copy your APB path and paste it here. (E.g. G:\Program Files (x86)\Steam\steamapps\common\APB Reloaded)
set /p apb=APB folder path: 
del /q "%cd%\Install\path.txt"
@echo %APB%> Install\path.txt
cls
GOTO MENU

:LSN
xcopy /s /y "install\Icon_file.ico" "%apb%\Binaries\."
xcopy /s /y "install/Last_stage_names" "%apb%"
cls

set MYPATH=%apb%
set SCRIPT="%TEMP%\%RANDOM%-%RANDOM%-%RANDOM%-%RANDOM%.vbs"
echo Set oWS = WScript.CreateObject("WScript.Shell") >> %SCRIPT%
echo sLinkFile = "%USERPROFILE%\Desktop\APB - Mission Names.lnk" >> %SCRIPT%
echo Set oLink = oWS.CreateShortcut(sLinkFile) >> %SCRIPT%
echo oLink.TargetPath = "%mypath%/Binaries/APB.exe" >> %SCRIPT%
echo oLink.Arguments = "-language=1031" >> %SCRIPT%
echo oLink.IconLocation = "%mypath%\Binaries\Icon_file.ico" >> %SCRIPT%
echo olink.WorkingDirectory = "%mypath%/Binaries/" >> %SCRIPT%
echo oLink.Save >> %SCRIPT%
cscript /nologo %SCRIPT%
del %SCRIPT%

set lsn=Installed and shortcut added to desktop
goto MENU

:LSF_PROMPT
cls
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the options below.
ECHO ---------------------------------------
ECHO 1 - Grey
ECHO 2 - Simple (Will allow new character creation)
ECHO 3 - Black
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO LSF_PROMPT) ELSE (GOTO LSF_LIST)

:LSF_LIST
IF %M%==1 GOTO LSF1
IF %M%==2 GOTO LSF2
IF %M%==3 GOTO LSF3
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO LSF_PROMPT
cls

:LSF1
xcopy /s /y "install/Login_screen_fix1" "%apb%"
cls
set lsf=Installed
goto MENU

:LSF2
xcopy /s /y "install/Login_screen_fix2" "%apb%"
cls
set lsf=Installed
goto MENU

:LSF3
xcopy /s /y "install/Login_screen_fix3" "%apb%"
cls
set lsf=Installed
goto MENU

:LQC_PROMPT
cls
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the configs below.
ECHO ---------------------------------------
ECHO 1 - Tobii's (Use Minimal preset!)
ECHO 2 - Frosi's (Use Minimal preset!)
ECHO 3 - Revers' (Use Minimal preset!)
ECHO 4 - Flaws' (Unknown)
ECHO 5 - Trauma's' (Unknown)
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what config to install and press ENTER: 

IF "%M%"=="" (GOTO LQC_PROMPT) ELSE (GOTO LQC_LIST)

:LQC_LIST
IF %M%==1 GOTO LQC1
IF %M%==2 GOTO LQC2
IF %M%==3 GOTO LQC3
IF %M%==4 GOTO LQC4
IF %M%==5 GOTO LQC4
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO LSF_PROMPT
cls

:LQC1
xcopy /s /y "install/Low_quality_config1" "%apb%"
cls
set lqc=Installed
goto MENU

:LQC2
xcopy /s /y "install/Low_quality_config2" "%apb%"
cls
set lqc=Installed
goto MENU

:LQC3
xcopy /s /y "install/Low_quality_config3" "%apb%"
cls
set lqc=Installed
goto MENU

:LQC4
xcopy /s /y "install/Low_quality_config4" "%apb%"
cls
set lqc=Installed
goto MENU

:LQC5
xcopy /s /y "install/Low_quality_config5" "%apb%"
cls
set lqc=Installed
goto MENU

:ASR
xcopy /s /y "install/Remove_ambient_sound" "%apb%"
cls
set asr=Installed
goto MENU

:EPF_PROMPT
cls
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the options below.
ECHO Be sure you use Minimal preset!
ECHO ---------------------------------------
ECHO 1 - Remove car fire/explosions - [%epf1%]
ECHO 2 - Remove grenade explosions - [%epf2%]
ECHO 3 - Remove Bullet holes effect - [%epf3%]
ECHO 4 - Remove Muzzle Flash - [%epf4%]
ECHO 5 - Remove Blood - [%epf5%]
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO EPF_PROMPT) ELSE (GOTO EPF_LIST)

:EPF_LIST
IF %M%==1 GOTO EPF1
IF %M%==2 GOTO EPF2
IF %M%==3 GOTO EPF3
IF %M%==4 GOTO EPF4
IF %M%==5 GOTO EPF5
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO EPF_PROMPT
cls

:EPF1
CLS
COLOR 46
ECHO NOTE: You NEED to install one of the login screen fixes, or the game will crash on launch!
pause
COLOR 2
cls
xcopy /s /y "install/remove_vehicle" "%apb%"
set epf=Installed
set epf1=Installed
goto EPF_PROMPT

:EPF2
CLS
COLOR 46
ECHO NOTE: You NEED to install one of the login screen fixes, or the game will crash on launch!
pause
COLOR 2
cls
xcopy /s /y "install/remove_explosions" "%apb%"
set epf=Installed
set epf2=Installed
goto EPF_PROMPT

:EPF3
CLS
xcopy /s /y "install/remove_effects_particles" "%apb%"
set epf=Installed
set epf3=Installed
goto EPF_PROMPT

:EPF4
xcopy /s /y "install/remove_muzzleflash" "%apb%"
cls
set epf=Installed
set epf4=Installed
goto EPF_PROMPT

:EPF5
xcopy /s /y "install/remove_blood" "%apb%"
cls
set epf=Installed
set epf5=Installed
goto EPF_PROMPT

:SCF
xcopy /s /y "install/sprint_crouch_fix" "%apb%"
cls
set scf=Installed
goto MENU

:MF
xcopy /s /y "install/misc_fixes" "%apb%"
del /q "%apb%\APBGame\Movies\*"
cls
set mf=Installed
goto MENU

:NFS
xcopy /s /y "install/nofog" "%apb%"
cls
set nfs=Installed
GOTO MENU

:NPC_PROMPT
cls
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the configs below.
ECHO ---------------------------------------
ECHO 1 - Install
ECHO 2 - Revert
ECHO 3 - Open NVIDIA Profile Inspector
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO NPC_PROMPT) ELSE (GOTO NPC_LIST)

:NPC_LIST
IF %M%==1 GOTO npc1
IF %M%==2 GOTO npc2
IF %M%==3 GOTO npc3
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO NPC_PROMPT
cls

:npc1
cls
start "" "%cd%/install/nvidia/nvidiaProfileInspector.exe" "%cd%/install/nvidia/APB.nip"
set npc=Installed
GOTO MENU

:npc2
cls
start "" "%cd%/install/nvidia/nvidiaProfileInspector.exe" "%cd%/install/nvidia/APB_default.nip"
set npc=Removed - Using default
GOTO MENU

:npc3
cls
start "" "%cd%/install/nvidia/nvidiaProfileInspector.exe"
GOTO NPC_PROMPT

:SHADERS
xcopy /s /y "install/Shaders" "%apb%"
cls
start notepad "%apb%\Engine\Shaders\Settings.usf"
ECHO -----------------------------------------
ECHO Shaders settings info is provided below.
ECHO -----------------------------------------
ECHO SET_FOG - 0 will remove distance fog. (0 by default)
ECHO SET_BLOOM - 0 will remove bloom. (0 by default)
ECHO SET_COLORGRADING - 0 will remove the blue tint color grading. (0 by default)
ECHO SET_CROSSHAIR - 1 will enable the crosshair shader. Additional changes have to be done in the CrosshairSettings.usf file. (1 by default)
ECHO SET_OUTLINE - 1 will enable the outline shader. Additional changes have to be done in the OutlinePixelShaderSettings.usf file. (0 by default)
ECHO.
ECHO Press any key when you've made changes to the settings file.
set SHADERS=Installed
pause >nul
GOTO MENU

:BACKUP_PROMPT
cls
tasklist /fi "imagename eq APB.exe" |find ":" > nul
if errorlevel 1 (
COLOR 46
ECHO ---------------------------------------
ECHO NOTE THAT APB.EXE IS RUNNING!
ECHO THIS COULD BREAK THE BACKUP/RESTORE PROCESS!
ECHO CLOSE THE PROCESS BEFORE CONTINUING!
ECHO ---------------------------------------
TaskMgr
tasklist /fi "imagename eq APB.exe" |find ":" > nul
if errorlevel 1 (
GOTO MENU
)
) else (
tasklist /fi "imagename eq APB_BE.exe" |find ":" > nul
if errorlevel 1 (
COLOR 46
ECHO ---------------------------------------
ECHO NOTE THAT APB_BE.EXE IS RUNNING!
ECHO THIS COULD BREAK THE BACKUP/RESTORE PROCESS!
ECHO CLOSE THE PROCESS BEFORE CONTINUING!
ECHO ---------------------------------------
TaskMgr
tasklist /fi "imagename eq APB_BE.exe" |find ":" > nul
if errorlevel 1 (
GOTO MENU
)
)
)
COLOR 2
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the options below.
ECHO ---------------------------------------
ECHO %backup%
ECHO.
ECHO B - Backup
ECHO R - Restore
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO BACKUP_PROMPT) ELSE (GOTO BACKUP_LIST)

:BACKUP_LIST
IF %M%==B GOTO BACKUP
IF %M%==b GOTO BACKUP
IF %M%==R GOTO RESTORE
IF %M%==r GOTO RESTORE
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO BACKUP_PROMPT
cls

:BACKUP
if not exist "%cd%\Backup\" mkdir "Backup"
if exist "%cd%\Backup\" RD /S /Q "Backup"
if not exist "%cd%\Backup\" mkdir "Backup"
del /q "%apb%\APBGame\Content\Audio\FilePackages\Dialogue_Russian.pck"
xcopy /s /y /i "%apb%\APBGame\Content\Release\Maps" "%cd%\Backup\APBGame\Content\Release\Maps"
xcopy /s /y /i "%apb%\APBGame\Content\Release\Packages\VFX" "%cd%\Backup\APBGame\Content\Release\Packages\VFX"
xcopy /s /y /i "%apb%\APBGame\Localization\GER" "%cd%\Backup\APBGame\Localization\GER"
xcopy /s /y /i "%apb%\APBGame\Config" "%cd%\Backup\APBGame\Config"
xcopy /s /y /i "%apb%\APBGame\Content\Audio" "%cd%\Backup\APBGame\Content\Audio"
xcopy /s /y /i "%apb%\APBGame\Movies" "%cd%\Backup\APBGame\Movies"
xcopy /s /y /i "%apb%\Binaries" "%cd%\Backup\Binaries"
xcopy /s /y /i "%apb%\Engine\Shaders" "%cd%\Backup\Engine\Shaders"

if exist "%cd%\Backup\" ( 
  for /f "skip=5 tokens=1,2,4 delims= " %%a in (
   'dir /ad /tc "%cd%\Backup\."') do IF "%%c"=="." (
    set "dt=%%a"
    set backup=Backup created on: %%a, %%b
  )
) else ( 
  set backup=No backup found
)

GOTO MENU

:RESTORE
if not exist "%cd%\Backup\" goto BACKUP_PROMPT
del /q "%apb%\Engine\Shaders\*.*"
xcopy /s /y /i "%cd%\Backup\*" "%apb%"
GOTO MENU

:TR
cls
del /q "%apb%\Content\Audio\MusicStudio\Instruments\*"
set tr=Installed
GOTO MENU

:EXIT
exit